/**
 * upload-api
 * Upload API
 *
 * The version of the OpenAPI document: 2.0.0
 * Contact: hello@upload.io
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
import * as runtime from "../runtime";
import type { BasicUploadResponse, BeginMultipartUploadRequest, BeginMultipartUploadResponse, CompleteUploadPartRequest, UploadFromUrlRequest, UploadPart, UploadPartList } from "../models";
export interface BeginMultipartUploadOperationParams {
    accountId: string;
    beginMultipartUploadRequest: BeginMultipartUploadRequest;
}
export interface CompleteUploadPartOperationParams {
    accountId: string;
    uploadId: string;
    uploadPartIndex: number;
    completeUploadPartRequest: CompleteUploadPartRequest;
}
export interface GetUploadPartParams {
    accountId: string;
    uploadId: string;
    uploadPartIndex: number;
}
export interface ListUploadPartsParams {
    accountId: string;
    uploadId: string;
}
export interface UploadFromUrlOperationParams {
    accountId: string;
    uploadFromUrlRequest: UploadFromUrlRequest;
}
/**
 *
 */
export declare class UploadApi extends runtime.BaseAPI {
    /**
     * Begins a new multipart file upload process.
     */
    private beginMultipartUploadWithHttpInfo;
    /**
     * Begins a new multipart file upload process.
     */
    beginMultipartUpload(requestParameters: BeginMultipartUploadOperationParams, initOverrides?: RequestInit | runtime.InitOverrideFunction): Promise<BeginMultipartUploadResponse>;
    /**
     * Marks an upload part as uploaded.  You must call this endpoint after you have successfully issued a `PUT` request to the `uploadUrl` on the corresponding UploadPart.
     */
    private completeUploadPartWithHttpInfo;
    /**
     * Marks an upload part as uploaded.  You must call this endpoint after you have successfully issued a `PUT` request to the `uploadUrl` on the corresponding UploadPart.
     */
    completeUploadPart(requestParameters: CompleteUploadPartOperationParams, initOverrides?: RequestInit | runtime.InitOverrideFunction): Promise<void>;
    /**
     * Gets a remaining upload part for a multipart file upload.
     */
    private getUploadPartWithHttpInfo;
    /**
     * Gets a remaining upload part for a multipart file upload.
     */
    getUploadPart(requestParameters: GetUploadPartParams, initOverrides?: RequestInit | runtime.InitOverrideFunction): Promise<UploadPart>;
    /**
     * Lists the remaining upload parts for a multipart file upload.  An empty array is returned when the upload is complete.
     */
    private listUploadPartsWithHttpInfo;
    /**
     * Lists the remaining upload parts for a multipart file upload.  An empty array is returned when the upload is complete.
     */
    listUploadParts(requestParameters: ListUploadPartsParams, initOverrides?: RequestInit | runtime.InitOverrideFunction): Promise<UploadPartList>;
    /**
     * Upload from a URL with a single HTTP request:
     */
    private uploadFromUrlWithHttpInfo;
    /**
     * Upload from a URL with a single HTTP request:
     */
    uploadFromUrl(requestParameters: UploadFromUrlOperationParams, initOverrides?: RequestInit | runtime.InitOverrideFunction): Promise<BasicUploadResponse>;
}
