/// <reference types="node" />
import type * as stream from "stream";
import type * as buffer from "buffer";
import { BlobLike } from "./Model";
/**
 * Provides access to Node.js built-in libraries. Should only be called when we're certain we're running in Node.js.
 *
 * We import lazily to support browsers, which don't have these modules, but also won't call these methods so won't trigger the imports.
 */
export declare class NodeUtils {
    static createStream(): Promise<stream.Readable>;
    static createBlob(sources: string[], options?: buffer.BlobOptions): Promise<BlobLike>;
}
